<?php
/**
 * A node console apt-proxy
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2011 - 2012 Apt-Proxy Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class NodeConsoleAptProxy extends BaseNodeAptProxy implements AptProxy, Registerable {
	/**
	 * Protected constructor
	 *
	 * @return	void
	 */
	protected function __construct () {
		// Call parent constructor
		parent::__construct(__CLASS__);
	}

	/**
	 * Creates an instance of this class
	 *
	 * @return	$proxyInstance	An instance of a AptProxy class
	 */
	public final static function createNodeConsoleAptProxy () {
		// Get new instance
		$proxyInstance = new NodeConsoleAptProxy();

		// Return the prepared instance
		return $proxyInstance;
	}

	/**
	 * Method to "bootstrap" the apt-proxy. This step does also apply provided
	 * command-line arguments stored in the request instance. You should now
	 * get it from calling $this->getRequestInstance().
	 *
	 * @return	void
	 */
	public function doBootstrapping () {
		$this->partialStub('Please implement this method.');
	}

	/**
	 * Outputs the console teaser. This should only be executed on startup or
	 * full restarts. This method generates some space around the teaser.
	 *
	 * @return	void
	 */
	public function outputConsoleTeaser () {
		// Get the app instance (for shortening our code)
		$app = $this->getApplicationInstance();

		// Output all lines
		self::createDebugInstance(__CLASS__)->debugOutput(' ');
		self::createDebugInstance(__CLASS__)->debugOutput($app->getAppName() . ' v' . $app->getAppVersion() . ' - An apt-proxy connection helper');
		self::createDebugInstance(__CLASS__)->debugOutput('Copyright (c) 2012 Apt-Proxy Developer Team');
		self::createDebugInstance(__CLASS__)->debugOutput(' ');
		self::createDebugInstance(__CLASS__)->debugOutput('This program comes with ABSOLUTELY NO WARRANTY; for details see docs/COPYING.');
		self::createDebugInstance(__CLASS__)->debugOutput('This is free software, and you are welcome to redistribute it under certain');
		self::createDebugInstance(__CLASS__)->debugOutput('conditions; see docs/COPYING for details.');
		self::createDebugInstance(__CLASS__)->debugOutput(' ');
	}

	/**
	 * Add some apt-proxy-specific filters
	 *
	 * @param	$controllerInstance		An object of a Controller instance
	 * @param	$responseInstance		An object of a Responseable instance
	 * @return	void
	 */
	public function addExtraFilters (Controller $controllerInstance, Responseable $responseInstance) {
		$this->partialStub('Please implement this method.');
	}
}

// [EOF]
?>
